#include <plib.h>
#include <p32xxxx.h>

/* Configuration Settings */
// OSC Input = HS w/PLL
// CPU Clock = ( ( OSC Input / 2 ) * 15 ) / 1
// PB Clock = CPU Clock / 1 
// Disabld WDT , ICSP/ICD = PGC2 , PGD2 
#pragma config FNOSC = PRIPLL , POSCMOD = HS
#pragma config FPLLIDIV = DIV_2 , FPLLMUL = MUL_15 , FPLLODIV = DIV_1
#pragma config FPBDIV = DIV_1
#pragma config FWDTEN = OFF , ICESEL = ICS_PGx2

#define SystemFrequency		60000000L
#define PBFrequency			60000000L
#define Timer1Tick			( PBFrequency / 256 / TogglesPerSec )
#define TogglesPerSec		10

void Timer1_Init( void );

void __ISR(_TIMER_1_VECTOR, ipl4 ) ISR_Imier1( void )
{	
	// To Do : MTimer_XСC
	mT1ClearIntFlag( );

	// LEDAϦVC
	mPORTAToggleBits( BIT_0 | BIT_1 | BIT_2 | BIT_3 | BIT_4 | BIT_5 | BIT_6 | BIT_7 );
}

int main( void )
{
	// Disable the JTAG function
	DDPCONbits.JTAGEN = 0;  				

	// ϥC32SYSTEM ConfigNCPUާ@̨ΤơAקFPBDIV]wC
	SYSTEMConfig( SystemFrequency , SYS_CFG_WAIT_STATES | SYS_CFG_PCACHE );
	// SYSTEMConfigPerformance( SystemFrequency  );
	// SYSTEMConfigWaitStates( SystemFrequency );

    INTEnableSystemMultiVectoredInt( );

	// To Do : ϥC32 Timer FunctionҥTimerAëw䤤_uvC
	ConfigIntTimer1( T1_INT_ON | T1_INT_PRIOR_4 );

	// To Do : ϥC32 Timer Functioni]wC
	OpenTimer1( T1_ON | T1_IDLE_CON | T1_GATE_OFF | T1_PS_1_256 | T1_SOURCE_INT , Timer1Tick );

    // LEDI/O Port]wƦXAëwI/O PortAC
    mPORTASetPinsDigitalOut( BIT_0 | BIT_1 | BIT_2 | BIT_3 | BIT_4 | BIT_5 | BIT_6 | BIT_7 );
    mPORTASetBits( BIT_0 | BIT_2 | BIT_4 | BIT_6 );
    mPORTAClearBits( BIT_1 | BIT_3 | BIT_5 | BIT_7 );

    while( 1 );
}
